/*
Module : ChooseDirDlg.h
Purpose: Interface for an MFC UI class to get a directory/folder using the IFileDialog interface

Copyright (c) 1997 - 2022 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Defines //////////////////////////////////////////////////

#pragma once

#ifndef __CHOOSEDIRDLG_H__
#define __CHOOSEDIRDLG_H__

#ifndef CCHOOSEDIRDLG_EXT_CLASS
#define CCHOOSEDIRDLG_EXT_CLASS
#endif //#ifndef CCHOOSEDIRDLG_EXT_CLASS

#ifndef CCHOOSEDIRDLG_EXT_API
#define CCHOOSEDIRDLG_EXT_API
#endif //#ifndef CCHOOSEDIRDLG_EXT_API


//////////////////// Classes //////////////////////////////////////////////////

class CCHOOSEDIRDLG_EXT_CLASS CChooseDirDlg : public ATL::CComPtr<IFileDialog>
{
public:
//Constructors / Destructors
  CChooseDirDlg(_In_ CWnd* pParentWnd, _In_ const CString& sTitle, _In_ FILEOPENDIALOGOPTIONS dwFlags = FOS_PICKFOLDERS | FOS_FORCEFILESYSTEM);
  CChooseDirDlg(const CChooseDirDlg&) = delete;
  CChooseDirDlg(CChooseDirDlg&&) = delete;
  ~CChooseDirDlg() = default;

//Methods
  CChooseDirDlg& operator=(const CChooseDirDlg&) = delete;
  CChooseDirDlg& operator=(CChooseDirDlg&&) = delete;
  HRESULT DoModal(_Inout_ CString& sDir);

protected:
//Member variables
  DWORD m_dwFlags;
  CString m_sTitle;
  CWnd* m_pParentWnd;
};

#endif //#ifndef __CHOOSEDIRDLG_H__
