#include "stdafx.h"
#include "testgetfolder.h"
#include "testgetfolderDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(suppress: 26455)
CTestgetfolderDlg::CTestgetfolderDlg(_In_opt_ CWnd* pParent) : CDialog{CTestgetfolderDlg::IDD, pParent},
                                                               m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CTestgetfolderDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_NONEMPTY, m_ctrlNotEmpty);
  DDX_Control(pDX, IDC_ENABLED, m_ctrlEnabled);
  DDX_Control(pDX, IDC_OVERWRITE_PROMPT, m_ctrlOverwritePrompt);
  DDX_Control(pDX, IDC_FOLDER_MUST_EXIST, m_ctrlFolderMustExist);
  DDX_Control(pDX, IDC_AUTOCOMPLETE, m_ctrlAutoComplete);
  DDX_Control(pDX, IDC_VISIBLE, m_ctrlVisible);
  DDX_FolderControl(pDX, IDC_FOLDER, m_ctrlGetFolder);
  DDX_FolderValue(pDX, m_ctrlGetFolder, m_sFolder);
  DDV_FolderControlIsFolder(pDX, m_ctrlGetFolder, IDP_DDXFOLDER_REQUIRE_VALID_FOLDER);
  if (m_ctrlOverwritePrompt.GetCheck())
    DDV_FolderControlOverwritePrompt(pDX, m_ctrlGetFolder);
  if (m_ctrlFolderMustExist.GetCheck())
    DDV_FolderControlMustExist(pDX, m_ctrlGetFolder, IDP_DDXFOLDER_REQUIRE_VALID_FOLDER);
  if (m_ctrlNotEmpty.GetCheck())
    DDV_FolderControlNotEmpty(pDX, m_ctrlGetFolder, IDP_DDXFOLDER_REQUIRE_VALID_FOLDER);
}

#pragma warning(suppress: 26440 26433)
BEGIN_MESSAGE_MAP(CTestgetfolderDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_READONLY, &CTestgetfolderDlg::OnReadonly)
  ON_BN_CLICKED(IDC_ENABLED, &CTestgetfolderDlg::OnEnabled)
  ON_BN_CLICKED(IDC_AUTOCOMPLETE, &CTestgetfolderDlg::OnAutoComplete)
  ON_BN_CLICKED(IDC_VISIBLE, &CTestgetfolderDlg::OnVisible)
END_MESSAGE_MAP()

BOOL CTestgetfolderDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //By default check the "Enabled" and visible check boxes
  m_ctrlEnabled.SetCheck(1);
  m_ctrlVisible.SetCheck(1);
  m_ctrlAutoComplete.SetCheck(m_ctrlGetFolder.GetAutoComplete());

  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestgetfolderDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this};

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CTestgetfolderDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestgetfolderDlg::OnReadonly()
{
  CDataExchange DX{this, TRUE};
  BOOL bReadOnly{FALSE};
#pragma warning(suppress: 26486)
  DDX_Check(&DX, IDC_READONLY, bReadOnly);
  m_ctrlGetFolder.SetReadOnly(bReadOnly);
}

void CTestgetfolderDlg::OnEnabled()
{
  if (m_ctrlEnabled.GetCheck() == 1)
    m_ctrlGetFolder.EnableWindow(TRUE);
  else
    m_ctrlGetFolder.EnableWindow(FALSE);
}

void CTestgetfolderDlg::OnAutoComplete()
{
  m_ctrlGetFolder.SetAutoComplete(m_ctrlAutoComplete.GetCheck() == 1);
}

void CTestgetfolderDlg::OnVisible()
{
  m_ctrlGetFolder.ShowWindow((m_ctrlVisible.GetCheck() == 1) ? SW_SHOW : SW_HIDE);
}
